
<template>
  <b-container class="border-bottom bg-white">
    <div class="d-md-flex justify-content-between">
      <NomVendeur :id="$route.params.idVendeur" />
      <div
        v-if="store.isConnected"
        class="d-flex align-items-center"
      >
        <div
          v-if="store.seller?.id != $route.params.idVendeur"
          class="mb-4"
        >
          <router-link v-if="vendeur.utilisateur"
            :to="{ name: 'Messages', params: { destinataireid: vendeur.utilisateur ? vendeur.utilisateur.id : '' }}"
            class="btn-cta m-1 p-2"
          >
            Contacter
          </router-link>
          <template v-if="isAbo == false">
            <button
              class="btn-cta"
              @click.prevent="abo()"
            >
              S'abonner
              <img
                :src="require('@/assets/icones/no-abo.svg')"
              >
            </button>
          </template>
          <template v-else>
            <button
              class="btn-cta"
              @click.prevent="abo()"
            >
              Se désabonner
              <img
                :src="require('@/assets/icones/abo.svg')"
              >
            </button>
          </template>
        </div>
        <template v-else>
          <router-link
            to="/profilproduits"
            class="btn-cta m-1"
          >
            Modifier mes produits
          </router-link>
        </template>
      </div>
      <div
        v-else
        class="d-flex align-items-center mb-4"
      >
        <router-link
          :to="{ name: 'Connexion'}"
          class="btn-cta m-1"
        >
          Se connecter pour contacter le ou la veudeur·euse
        </router-link>
      </div>
    </div>
    <div class="d-flex justify-content-between">
      <p class="w-75">
        {{ vendeur.description }}
      </p>
    </div>
  </b-container>
</template>

<script>
import NomVendeur from '@/components/NomVendeur.vue';
import axios from 'axios';
import { useStore } from '@/store/store';

export default {
  components: {
    NomVendeur
  },

  props: {
    pseudo: String,
    image: {
      default: false
    }
  },

  data() {
    return {
      apiUrl: process.env.VUE_APP_URL,
      vendeur: '',
      isAbo: '',
      idAbo: '',
      store: useStore(),
    }
  },

  watch: {
      '$route.params.idVendeur': function () {
          this.loadData();
      },
  },

  mounted(){
    this.loadData();
    //on voit si l'utilisateur est abonné ou non
    if(this.store.isConnected){
      console.log('connect');
      axios({
        method: 'get',
        url: this.apiUrl + "/api/utilisateurs/abo/" + this.store.user.id + "/" + this.$route.params.idVendeur,
      })
      .then(res => {
        console.log(res.data);
        if(res.data['hydra:member'].length > 0){
          this.idAbo = res.data['hydra:member'][0].id;
          this.isAbo = true;
        } else {
          this.isAbo = false;
          this.idAbo = null;
        }
      })
      .catch(err => {
          console.log(err);
      });
    }
  },

  methods: {

    loadData(){
      // on récupère les info du vendeur
      axios({
        method: 'get',
        url: this.apiUrl + "/api/info_vendeurs/" + this.$route.params.idVendeur,
      })
      .then(res => {
        this.vendeur = res.data;
        console.log(res.data);
      })
      .catch(err => {
          console.log(err);
      });
    },

    abo() {
      if(this.store.isConnected){
        if(this.idAbo == null){
          axios.post(this.apiUrl + "/api/abonnements", {
              "utilisateur": "api/utilisateurs/" + this.store.user.id,
              "infoVendeur": "api/info_vendeurs/" + this.$route.params.idVendeur
          })
          .then(res => {
            this.idAbo = res.data.id;
            this.isAbo = true;
          })
          .catch(err => {
              console.log(err);
          })
        } else {
          axios.delete(this.apiUrl + "/api/abonnements/" + this.idAbo)
          .then(res => {
            this.isAbo = false;
            this.idAbo = null
          })
          .catch(err => {
              console.log(err);
          })
        }
        this.store.fetchUser();
      }
    }

  }

}
</script>

<style lang="scss" scoped>

</style>
